// main.cpp

#include <windows.h>
#include <tchar.h>
#include "resource.h"

//-----------------------------------------------------------------

HINSTANCE g_hinstExe			= NULL;
HWND g_hwndMain					= NULL;
BOOL g_fFlashing				= FALSE;

//-----------------------------------------------------------------

BOOL MyTerminateProcess(DWORD dwProcessId) {
	BOOL fSuccess = FALSE;
	HANDLE hProcess = OpenProcess(PROCESS_TERMINATE, FALSE, dwProcessId);
	if (hProcess) {
		fSuccess = TerminateProcess(hProcess, (UINT)-1);
		CloseHandle(hProcess);
	}
	return(fSuccess);
}

//-----------------------------------------------------------------

INT_PTR CALLBACK Dlg_MainProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {

	switch(uMsg) {

		case WM_COMMAND: {
			if (HIWORD(wParam) == BN_CLICKED) {
				int id = LOWORD(wParam);
				switch (id) {

					case IDC_IDLE_PRIORITY_CLASS:
					case IDC_BELOWNORMAL_PRIORITY_CLASS:
					case IDC_NORMAL_PRIORITY_CLASS:
					case IDC_ABOVENORMAL_PRIORITY_CLASS:
					case IDC_HIGH_PRIORITY_CLASS:
					case IDC_REALTIME_PRIORITY_CLASS: {
						DWORD dwPriority = NORMAL_PRIORITY_CLASS;
						if (IsDlgButtonChecked(hwnd, IDC_IDLE_PRIORITY_CLASS) == BST_CHECKED) {
							dwPriority = IDLE_PRIORITY_CLASS;
						} else if (IsDlgButtonChecked(hwnd, IDC_BELOWNORMAL_PRIORITY_CLASS) == BST_CHECKED) {
							dwPriority = BELOW_NORMAL_PRIORITY_CLASS;
						} else if (IsDlgButtonChecked(hwnd, IDC_ABOVENORMAL_PRIORITY_CLASS) == BST_CHECKED) {
							dwPriority = ABOVE_NORMAL_PRIORITY_CLASS;
						} else if (IsDlgButtonChecked(hwnd, IDC_HIGH_PRIORITY_CLASS) == BST_CHECKED) {
							dwPriority = HIGH_PRIORITY_CLASS;
						} else if (IsDlgButtonChecked(hwnd, IDC_REALTIME_PRIORITY_CLASS) == BST_CHECKED) {
							dwPriority = REALTIME_PRIORITY_CLASS;
						}
						SetPriorityClass(GetCurrentProcess(), dwPriority);
						break;
													  }

					case IDC_HANGPROCESS: {
//#pragma optimize("", off)
						volatile int n;
						for (int i = 0; ; i++)
							n = i;
//#pragma optimize("", on)
						break;
										  }

					case IDC_CRASHPROCESS: {
						ZeroMemory(NULL, 100);
						int a = 0;
						int b = 100 / a;
						break;
										   }

					case IDC_FLASHWINDOW: {
						
						g_fFlashing = !g_fFlashing;

						FLASHWINFO fwi;
						fwi.cbSize = sizeof(fwi);
						fwi.hwnd = hwnd;
						fwi.dwFlags = g_fFlashing ? (FLASHW_ALL | FLASHW_TIMER) : FLASHW_STOP;
						fwi.uCount = -1;
						fwi.dwTimeout = 0;
						FlashWindowEx(&fwi);

						SetDlgItemText(hwnd, IDC_FLASHWINDOW, g_fFlashing 
							? _T("Stop flashing") : _T("Start flashing"));
						break;
										  }

					case IDC_KILLSHELL: {
						HWND hwndShell = GetShellWindow();
						DWORD dwProcessId;
						GetWindowThreadProcessId(hwndShell, &dwProcessId);
						if (!MyTerminateProcess(dwProcessId)) {
							MessageBox(hwnd, _T("Could not terminate shell process. Access denied!"), 
								_T("Error"), MB_OK | MB_ICONERROR);
						}
						break;
										}

					case IDOK:
					case IDCANCEL:
						EndDialog(hwnd, FALSE);
						break;
				}
			}
			break;
						 }
		case WM_INITDIALOG:
			g_hwndMain = hwnd;
			SendMessage(hwnd, WM_SETICON, ICON_BIG, 
				(LONG)(LONG_PTR)LoadIcon(NULL, IDI_ERROR));
			SendMessage(hwnd, WM_SETICON, ICON_SMALL, 
				(LONG)(LONG_PTR)LoadIcon(NULL, IDI_ERROR));

			DWORD dwPriority = GetPriorityClass(GetCurrentProcess());
			int idc = IDC_NORMAL_PRIORITY_CLASS;
			switch (dwPriority) {
				case IDLE_PRIORITY_CLASS:
					idc = IDC_IDLE_PRIORITY_CLASS;
					break;
				case BELOW_NORMAL_PRIORITY_CLASS:
					idc = IDC_BELOWNORMAL_PRIORITY_CLASS;
					break;
				case ABOVE_NORMAL_PRIORITY_CLASS:
					idc = IDC_ABOVENORMAL_PRIORITY_CLASS;
					break;
				case HIGH_PRIORITY_CLASS:
					idc = IDC_HIGH_PRIORITY_CLASS;
					break;
				case REALTIME_PRIORITY_CLASS:
					idc = IDC_REALTIME_PRIORITY_CLASS;
					break;
			}
			CheckDlgButton(hwnd, idc, BST_CHECKED);
			break;
	}
	return(0);
}

//-----------------------------------------------------------------

#ifdef _DEBUG
int APIENTRY _tWinMain(HINSTANCE hinstExe, HINSTANCE, LPTSTR, int) {
#else
void APIENTRY _myWinMain() {
#endif

	g_hinstExe = GetModuleHandle(NULL);
	DialogBox(g_hinstExe, MAKEINTRESOURCE(IDD_MAIN), NULL, Dlg_MainProc);

#ifdef _DEBUG
	return(0);
#else
	ExitProcess(0);
#endif
}

//-----------------------------------------------------------------
